using System;

using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using System.Text;
using Com.Google.Ads;
using Android.Locations;


namespace FrackinReserve
{
	[Activity (Label = "FRACKIN' RESERVE - END THE FED", MainLauncher = true)]
	public class Activity1 : Activity, GestureDetector.IOnGestureListener, ILocationListener
	{
		string[] compoundedItems = new string[] 
		{ "Annually", "Monthly", "Daily", "Hourly", 
			"By the minute", "By the second" }; // , "By the yottasecond" }; // , "By the \"tick\"" }; // Android ticks are much larger than Windows NT ticks.
		// We can't do the ys because we need numbers that are too big and others that are too small.

		// Icon info:
		// http://www.glassybuttons.com/glassy.php
		// http://www.iconarchive.com/show/keriyo-emoticons-icons-by-deleket/Smiley-dollar-icon.html
		// Good post here:
		// http://stackoverflow.com/questions/5350624/set-icon-for-android-application

		AdView adView;

		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// get the display info
			Display disp = WindowManager.DefaultDisplay;
			/* Console.WriteLine ("Width = " + disp.Width.ToString () 
				+ "  Height = " + disp.Height.ToString () 
				+ "  Pix = " + disp.PixelFormat.ToString () 
				+ "  Orien = " + disp.Orientation.ToString ()  
				+ "  Rot = " + disp.Rotation.ToString ()); */
			
			Android.Util.DisplayMetrics dm = new Android.Util.DisplayMetrics ();
			disp.GetMetrics (dm);

			if (dm.WidthPixels < 540) {
				SetContentView (Resource.Layout.MainSmall);
			} else {
				// Set our view from the "main" layout resource
				SetContentView (Resource.Layout.Main);
			}
			int asdf = 0;

			// Initial deposit wireup
			SeekBar skStart = FindViewById<SeekBar> (Resource.Id.seekInitialDeposit);
			skStart.ProgressChanged += OnSeekInitialDeposit;

			Button resetInitDep = FindViewById<Button> (Resource.Id.btnResetInitialDeposit);
			resetInitDep.Click += OnResetInitialDeposit;

			// Reserve requirement wireup
			SeekBar skResReq = FindViewById<SeekBar> (Resource.Id.seekReserveRequirement);
			skResReq.ProgressChanged += OnSeekReserveRequirement;

			Button bResReset = FindViewById<Button> (Resource.Id.btnResetResReq);
			bResReset.Click += OnResetReserveRequirement;

			// Iterations wireup
			SeekBar skIter = FindViewById<SeekBar> (Resource.Id.seekIterations);
			skIter.ProgressChanged += OnSeekIterations;
			
			Button bIter = FindViewById<Button> (Resource.Id.btnResetIterations);
			bIter.Click += OnResetIterations;

			// Interest periods
			SeekBar skIntPeriods = FindViewById<SeekBar> (Resource.Id.seekInterestPeriods);
			skIntPeriods.ProgressChanged += OnSeekInterestPeriods;

			Button bIntPer = FindViewById<Button> (Resource.Id.btnResetInterestPeriods);
			bIntPer.Click += OnResetInterestPeriods;

			// Interest rate
			SeekBar skIntRate = FindViewById<SeekBar> (Resource.Id.seekInterestRate);
			skIntRate.ProgressChanged += OnSeekInterestRate;

			Button bIntRate = FindViewById<Button> (Resource.Id.btnResetInterestRate);
			bIntRate.Click += OnResetInterestRate;

			// Interest compouding method
			Spinner spnCompounded = FindViewById<Spinner> (Resource.Id.spinCompounded);
			ArrayAdapter ad = new ArrayAdapter 
				(this, Android.Resource.Layout.SimpleSpinnerItem, compoundedItems);
			ad.SetDropDownViewResource (Android.Resource.Layout.SimpleSpinnerDropDownItem);
			spnCompounded.Adapter = ad;
			spnCompounded.ItemSelected += OnCompoundedSelected;
			// Set the default to Monthly - index 1
			spnCompounded.SetSelection (1);

			Button bCompound = FindViewById<Button> (Resource.Id.btnResetCompounded);
			bCompound.Click += OnResetCompounded;

			// Set up the chart button
			Button btnChart = FindViewById<Button> (Resource.Id.btnShowMe);
			btnChart.Click += OnShowMe;


			// Spin up the ad...
			// Create an ad.
			/* 
			 * This section here is for wiring up an ad in code.
			 * However, you can equally just wire it up in the layout AXML file.*/
			adView = FindViewById<AdView> (Resource.Id.adView);
			
			// Create an ad request.
			AdRequest adRequest = new AdRequest ();
			/* adRequest.SetTesting (true);
			adRequest.AddTestDevice("049F5A8D4990A8C390EFF14140062D58");   */

			//adRequest.AddTestDevice (AdRequest.TestEmulator); 
			/*  */
			adRequest.AddKeyword ("silver");
			adRequest.AddKeyword ("gold");
			adRequest.AddKeyword ("bullion");
			adRequest.AddKeyword ("survival");
			adRequest.AddKeyword ("prepper");  
			adRequest.AddKeyword ("economic collapse");
			adRequest.AddKeyword ("forex trading");
			adRequest.AddKeyword ("silver coins");
			adRequest.AddKeyword ("fractional reserve banking");

			// location
			LocationManager lmanager = (LocationManager)this.GetSystemService (Context.LocationService);
			Location currentLoc;
			try {
				if (lmanager.IsProviderEnabled (LocationManager.NetworkProvider)) {
					currentLoc = lmanager.GetLastKnownLocation (LocationManager.NetworkProvider);
					if (currentLoc != null) {
						adRequest.SetLocation (currentLoc);
					}
				} 
			} catch {
				// It failed. That sucks. :(
			}

			adView.LoadAd(adRequest);


			// Update the initial UI
			DoFractionalMath ();
			_gestureDetector = new GestureDetector (this);

		}

		protected override void OnStop ()
		{
			base.OnStop ();
			// Save the settings here - we'll do that later for v1.1 or something.
		}


		protected void SaveSetting(string name, string value)
		{
			var prefences = GetSharedPreferences("Params", FileCreationMode.Private);
			var editor = prefences.Edit();
			editor.Remove(name);
			editor.PutString(name, value);
			editor.Commit();
		}








		/*protected override void OnDestroy ()
		{
			// Destroy the AdView.
			adView.Destroy();
			
			base.OnDestroy ();
		}*/

		// Location data
		#region Location listener

		public void OnLocationChanged(Location location)
		{

		}
		
		public void OnProviderDisabled(string provider)
		{

		}
		
		public void OnProviderEnabled(string provider)
		{

		}
		
		public void OnStatusChanged(string provider, Availability status, Bundle extras)
		{

		}

		#endregion

		#region Context Menu

		public override bool OnCreateOptionsMenu (IMenu menu)
		{
			var omRateUs = menu.Add (0,1,1, "Rate FR!");
			var omVisitUs = menu.Add(0,2,2, "Visit FR!");

			//return base.OnCreateOptionsMenu (menu);
			return true;
		}

		public override bool OnOptionsItemSelected (IMenuItem item)
		{
			switch (item.ItemId) {
				case 1:
					// Do menu item 1
					RateThisApp();
					return true;
					break;
				case 2:
					// do menu item 2
					VisitFrackinReserve();
					return true;
					break;
				default:
					break;
			}

			return base.OnOptionsItemSelected(item);
		}


		private void VisitFrackinReserve ()
		{
			var intent = new Intent (Intent.ActionView, 
			                         Android.Net.Uri.Parse ("http://cynic.me/tag/fractional-reserve-banking/"));
			intent.AddFlags (ActivityFlags.NewTask);
			try {
				StartActivity (intent);
			} catch {
				Toast.MakeText(this.ApplicationContext, 
				               "Sorry... \r\nEither Cthulhu or the Banksters sabotaged our efforts...", ToastLength.Long).Show();
			}
		}

		private void RateThisApp ()
		{
			Android.Net.Uri uri = Android.Net.Uri.Parse("market://details?id=" + this.PackageName);
			 
			Intent goToMarket = new Intent(Intent.ActionView, uri);
			goToMarket.AddFlags (ActivityFlags.NewTask);
			try {
				StartActivity(goToMarket);
			} catch (ActivityNotFoundException err) {
				// UtilityClass.ShowAlertDialog(Context, ERROR, "Couldn't launch the market", null, 0);
				Toast.MakeText(this.ApplicationContext, "Sorry... Couldn't launch the market...", ToastLength.Long).Show();
			}
		}
		#endregion

		void OnShowMe (object sender, EventArgs e)
		{
			ShowHtmlChart();
		}

		private void ShowHtmlChart ()
		{
			string assHtml = AssembleHtml ();
			//Console.Write (Html);
			var second = new Intent(this, typeof(HtmlChart));
			second.PutExtra("HtmlData", assHtml);
			StartActivity (second);
		}

		// Assemble the HTML
		private string AssembleHtml ()
		{
			// This assembles the HTML with the constants below, and the Html variable as it is updated in the DoFractionalMath() method above.
			// But first, sub in the interest for the header...
			string html1Sub = html1;
			TextView tvIntPer = FindViewById<TextView> (Resource.Id.txtInterestPeriods);
			TextView tvIntRate = FindViewById<TextView> (Resource.Id.txtInterestRate);
			string ip = CleanTextNumber(tvIntPer.Text).ToString("###,###");
			string ir = (CleanTextNumber(tvIntRate.Text)).ToString("##0.0");
			html1Sub = html1Sub.Replace("{0}", ip).Replace("{1}", ir); 
			// This assembles it. 
			string result = html1Sub + Html + html2;

			return result;
		}


		#region Interest UI methods

		void OnResetCompounded (object sender, EventArgs e)
		{
			Spinner spnCompounded = FindViewById<Spinner> (Resource.Id.spinCompounded);
			spnCompounded.SetSelection (1);
			//DoFractionalMath ();
		}

		void OnResetInterestRate (object sender, EventArgs e)
		{
			SeekBar skIntRate = FindViewById<SeekBar> (Resource.Id.seekInterestRate);
			skIntRate.Progress = 5;
			//DoFractionalMath ();
		}

		void OnResetInterestPeriods (object sender, EventArgs e)
		{
			SeekBar skIntPeriods = FindViewById<SeekBar> (Resource.Id.seekInterestPeriods);
			skIntPeriods.Progress = 10;
			//DoFractionalMath ();
		}

		void OnSeekInterestRate (object sender, SeekBar.ProgressChangedEventArgs e)
		{
			TextView tvIntRate = FindViewById<TextView> (Resource.Id.txtInterestRate);
			tvIntRate.SetText (e.Progress.ToString () + "%", TextView.BufferType.Normal);
			DoFractionalMath ();
		}

		void OnSeekInterestPeriods (object sender, SeekBar.ProgressChangedEventArgs e)
		{
			TextView tvIntPer = FindViewById<TextView> (Resource.Id.txtInterestPeriods);
			tvIntPer.SetText (e.Progress.ToString (), TextView.BufferType.Normal);
			DoFractionalMath ();
		}

		int compoundedIndex = 1;
		void OnCompoundedSelected (object sender, AdapterView.ItemSelectedEventArgs e)
		{
			var s = sender as Spinner;
			compoundedIndex = e.Position;
			DoFractionalMath ();
		}

		#endregion
		

		#region "Wiring up the main initial parameters"

		/// <summary>
		/// Raises the iterations event.
		/// </summary>
		/// <param name='sender'>
		/// Sender.
		/// </param>
		/// <param name='e'>
		/// E.
		/// </param>
		void OnSeekIterations (object sender, SeekBar.ProgressChangedEventArgs e)
		{
			TextView txtIter = FindViewById<TextView> (Resource.Id.txtIterations);
			txtIter.SetText (e.Progress.ToString(), TextView.BufferType.Normal);
			DoFractionalMath ();
		}

		void OnResetIterations (object sender, EventArgs e)
		{
			SeekBar skIter = FindViewById<SeekBar> (Resource.Id.seekIterations);
			// reset the value
			skIter.Progress = 10;
			//DoFractionalMath ();
		}

		void OnResetReserveRequirement (object sender, EventArgs e)
		{
			SeekBar skRes = FindViewById<SeekBar> (Resource.Id.seekReserveRequirement);
			// reset the value
			skRes.Progress = 10;
			//DoFractionalMath ();
		}

		void OnSeekReserveRequirement (object sender, SeekBar.ProgressChangedEventArgs e)
		{
			TextView txtResReq = FindViewById<TextView> (Resource.Id.txtResReq);
			txtResReq.SetText (e.Progress.ToString() + "%", TextView.BufferType.Normal);
			DoFractionalMath ();
		}

		void OnResetInitialDeposit (object sender, EventArgs e)
		{		
			SeekBar skStart = FindViewById<SeekBar> (Resource.Id.seekInitialDeposit);
			// reset the value
			skStart.Progress = 1000;
			//DoFractionalMath ();
		}

		void OnSeekInitialDeposit (object sender, SeekBar.ProgressChangedEventArgs e)
		{
			TextView tv = FindViewById<TextView> (Resource.Id.txtSamount);
			tv.SetText("$" + e.Progress.ToString (), TextView.BufferType.Normal);
			DoFractionalMath ();
		}

		#endregion

		#region Fractional math calculations

		private void DoFractionalMath()
		{

			SeekBar skInterestRate = FindViewById<SeekBar> (Resource.Id.seekInterestRate);
			SeekBar skInterestPeriods = FindViewById<SeekBar> (Resource.Id.seekInterestPeriods);
			decimal interestRate = (decimal)skInterestRate.Progress/100;
			decimal interestPeriods = (decimal)skInterestPeriods.Progress;
			// This is the fraction of the money that must be held in reserve by the bank. 
			// It is also called the "reserve ratio", "reserve requirement", or "cash reserve ratio".
			// Its maximum value is 1, and its minimum value is "greater than zero", that is,
			// It can be as small as imaginable, but cannot be zero. 
			// i.e. anything divided by zero is undefined, or infinitely infinite, which is mathematically absurd. 
			// Note that some countries actually have the fractional reserve amount set to zero!
			// http://en.wikipedia.org/wiki/Reserve_requirement
			// Those countries include Australia, Canada, New Zealand, and Sweden. 
			SeekBar skResReq = FindViewById<SeekBar> (Resource.Id.seekReserveRequirement);

			decimal fractionalReserveFactor = (decimal)skResReq.Progress/100;
			// This is the number of times that the money goes through the cycle. 
			// The first time this happens is the initial deposit into the system. 
			// From the second time on, all adhere to the fractional reserve system. 
			
			SeekBar skIter = FindViewById<SeekBar> (Resource.Id.seekIterations);
			Int32 iterations = Convert.ToInt32(skIter.Progress);
			// We need to keep track of the last amount that was available to lend out. 
			// For the first iteration, this amount is the intitial deposit. 
			
			SeekBar skInit = FindViewById<SeekBar> (Resource.Id.seekInitialDeposit);
			decimal lastAmountToLendAmount = (decimal)skInit.Progress;
			
			// We're going to keep track of some running totals.
			// This is the total amount that the bank *can* lend out. 
			// It includes any fund that the bank *has* lent out.
			decimal runningSumOfCanLendOut = 0M;
			// This is the total amount of money of all customers that people believe that they have. 
			// All money in excess of the initial deposit is fictious. 
			decimal runningSumOfCustomerAccounts = 0M;
			// This is the total amount of money that the bank has kept in reserve. 
			// This can never go above the initial deposit. 
			decimal runningSumOfFractionallyReservedFunds = 0M;
			// This is the total amount of money that the bank has lent out. 
			// This amount minus the initial deposit is the amount of fictious money. 
			decimal runningSumOfHasLentOut = 0M;
			
			// This variable holds the HTML that we'll display. 
			StringBuilder sbHtmlTable = new StringBuilder();
			
			// We need to loop through the fractional reserve logic for each iteration. 
			// An iteration is basically whenever a person deposits money and another person borrows. 
			// See the graphic at http://cycnic.me for an easy way to understand the DoFractionalMath() method.
			for (int i = 1; i <= iterations; i++)
			{
				// Total up all the customers accounts first.
				runningSumOfCustomerAccounts += lastAmountToLendAmount;
				// Compute the amount of money that the bank must withhold (the deposit minus the fractional reserve)
				decimal tmpFractionalReserveWithheldInBank = lastAmountToLendAmount * fractionalReserveFactor;
				// Total up the amount of funds held in reserve
				runningSumOfFractionallyReservedFunds += tmpFractionalReserveWithheldInBank; //lastAmountToLendAmount * (1 - fractionalReserveFactor);
				// Total up the amount lent out to people
				runningSumOfCanLendOut += lastAmountToLendAmount - tmpFractionalReserveWithheldInBank;
				
				#region HTML
				// Do the HTML if required:
				if (DoHtml)
				{
					// This creates the rows for the table. 
					sbHtmlTable.AppendLine(
						string.Format(
						// This is a formatting string for our rows. It represents 1 row. The values below are substituted into it wherever you
						// see {#}, where # is some number. 
						"<tr><td>{0}</td><td>{1}</td><td>{2}</td><td>{3}</td><td>{4}</td><td>{5}</td><td>{6}</td><td>{7}</td><td>{8}</td></tr>", 
						// the iteration #
						i.ToString(),
						// amount deposited into bank by customer
						lastAmountToLendAmount.ToString("###,###,###,##0.00"),
						// amount held in reserve
						tmpFractionalReserveWithheldInBank.ToString("###,###,###,##0.00"),
						// amount currently available to lend out
						(lastAmountToLendAmount - tmpFractionalReserveWithheldInBank).ToString("###,###,###,##0.00"),
						// amount that *can* be lent out
						runningSumOfCanLendOut.ToString("###,###,###,##0.00"),
						// amount that has been lent out
						runningSumOfHasLentOut.ToString("###,###,###,##0.00"),
						// the amount that the bank has available for withdrawl
						runningSumOfFractionallyReservedFunds.ToString("###,###,###,##0.00"),
						// the amount that customers believe that they have in the bank
						runningSumOfCustomerAccounts.ToString("###,###,###,##0.00"),
						// this is the interest that can never be repaid:
						// F = P * (1 + r/n)^(n*t) - P
						// -- This one here is for 5% for 1 year
						//((Convert.ToDouble(runningSumOfHasLentOut) * Math.Pow(1f + 0.05f / 12f, 1 * 12)) - Convert.ToDouble(runningSumOfHasLentOut)).ToString("###,###,###,##0.00")
						// This does the running sum of the amount that cannot be repaid. 
						// It's put in a method to avoid having a big huge mess here that would only make things unreadable. 


						DoInterestP(runningSumOfHasLentOut, interestRate, Convert.ToInt32(interestPeriods)).ToString("###,##0.00")
						)
						);
				}
#endregion
				
				// If we are at the last iteration, do not do this. 
				if (i < iterations)
				{
					runningSumOfHasLentOut += lastAmountToLendAmount - tmpFractionalReserveWithheldInBank;
				}
				
				// This is the magic where fractional reserve banking invents money:
				//   tmpFractionalReserveWithheldInBank is the amount mandated that the bank must withhold in reserve.
				//   It is equal to the amount deposited times the "reserve requirement". 
				//   By removing the reserve requirement from the amount deposited, 
				//     we come up with the amount that is available to lend out. 
				lastAmountToLendAmount = lastAmountToLendAmount - tmpFractionalReserveWithheldInBank;
			}
			
			// These update the UI. 
			TextView tvCustThink = FindViewById<TextView> (Resource.Id.txtWhatCustThink);
			tvCustThink.SetText (runningSumOfCustomerAccounts.ToString ("$#,##0.00"), TextView.BufferType.Normal);
			
			TextView tvBankReserves = FindViewById<TextView> (Resource.Id.txtBankReserves);
			tvBankReserves.SetText (runningSumOfFractionallyReservedFunds.ToString("$#,##0.00"), TextView.BufferType.Normal);

			TextView tvBankCanLoan = FindViewById<TextView> (Resource.Id.txtBankCanLoan);
			tvBankCanLoan.SetText(runningSumOfCanLendOut.ToString ("$#,##0.00"), TextView.BufferType.Normal);

			TextView tvBankHasLoaned = FindViewById<TextView> (Resource.Id.txtBankHasLoaned);
			tvBankHasLoaned.SetText (runningSumOfHasLentOut.ToString ("$#,##0.00"), TextView.BufferType.Normal);

			
			//nudFakeTotal.Value = nudWhatTheBankCanLoanOut.Value + nudWhatTheBankHasInReserve.Value;

			TextView tvBankNextLoan = FindViewById<TextView> (Resource.Id.txtBanksNextLoan);
			tvBankNextLoan.SetText((runningSumOfCanLendOut - runningSumOfHasLentOut).ToString ("$#,##0.00"), TextView.BufferType.Normal);

			// Once we've calculated everything for the fractional reserve banking, we can figure out what
			// possible interest could be, and so we run the DoInterest() method. 
			DoInterest();
			
			// Display the HTML if needed.
			if (DoHtml)
			{
				// This updates our Html variable so we can use it below. 
				Html = sbHtmlTable.ToString();
			}
		}

		private void DoInterest()
		{
			// The number of times to calculate the interest on.
			// Set it to montly by default.
			double times = 12;
			// Choose how to compound the interest.
			switch (compoundedIndex)
			{
			case 0:
				// Annually
				times = 1;
				break;
			case 1:
				// Monthly
				times = 12;
				break;
			case 2:
				// Daily
				times = 365.25; // include leap years
				break;
			case 3:
				// hourly
				times = 365.25 * 24; // hours in a year
				break;
			case 4:
				// By the minute
				times = 365.25 * 24 * 60; // minutes in a year
				break;
			case 5:
				// By the second
				times = 365.25 * 24 * 60 * 60; // seconds in a year
				break;
			/* case 6: // this is for desktop OSes
				// By ticks
				times = 365.25 * 24 * 60 * 60 * TimeSpan.TicksPerSecond; // ticks in a year
				break; */
			case 6:
				// By the yottasecond
				times = 365.25 * 24 * 60 * 60 * Math.Pow (10, 6);
				Console.WriteLine("YOTTA: " + times.ToString ());
				break;
			default:
				// Set the default to monthly:
				times = 12;
				break;
			}
			
			// final = principal * (1 + (interest rate / number of times compounded)) ^ (years compounded * number of times compounded)
			// F = P * (1 + r/n)^(n*t)
			// This is (interest rate / number of times compounded).
			SeekBar sbIntRate = FindViewById<SeekBar> (Resource.Id.seekInterestRate);
			double rn = ((double)sbIntRate.Progress/(double)100) / times;
			// This is (years compounded * number of times compounded).
			SeekBar sbIntPer = FindViewById<SeekBar> (Resource.Id.seekInterestPeriods);
			double nt = Convert.ToDouble(sbIntPer.Progress) * times;
			// This is the principal.
			TextView tvBankHasLoaned = FindViewById<TextView> (Resource.Id.txtBankHasLoaned);
			double P = Convert.ToDouble(CleanTextNumber(tvBankHasLoaned.Text));
			// This is the final value.
			double F = P * Math.Pow(1 + rn, nt);
			//Console.WriteLine("rn = " + rn.ToString ());
			//Console.WriteLine("nt = " + nt.ToString ());
			//Console.WriteLine("P = " + P.ToString ());
			//Console.WriteLine ("F = " + F.ToString ());
			//Console.WriteLine("Bank has loaned: " + tvBankHasLoaned.Text);
			// This is only the interest part, i.e. the final value - the principal.
			TextView tvTotInt = FindViewById<TextView> (Resource.Id.txtTotalInterest);
			double totalInterest = Convert.ToDouble (F) -  CleanTextNumber(tvBankHasLoaned.Text);
			tvTotInt.SetText (totalInterest.ToString ("$#,##0.00"), TextView.BufferType.Normal);

			// This is the final value. 
			TextView tvIntPrinc = FindViewById<TextView> (Resource.Id.txtInterestAndPrincipal);
			tvIntPrinc.SetText(F.ToString("$#,##0.00"), TextView.BufferType.Normal);

		}

		private double CleanTextNumber (string number)
		{
			double result = 0;

			string tmp = number.Replace (",","").Replace ("$","").Replace ("%","");
			result = double.Parse (tmp);

			return result;
		}

		private double DoInterestP(decimal principal, decimal rate, int time)
		{
			
			// The number of times to calculate the interest on.
			// Set it to montly by default.
			double times = 12;
			// Choose how to compound the interest.

			switch (compoundedIndex)
			{
			case 0:
				// Annually
				times = 1;
				break;
			case 1:
				// Monthly
				times = 12;
				break;
			case 2:
				// Daily
				times = 365.25; // include leap years
				break;
			case 3:
				// hourly
				times = 365.25 * 24; // hours in a year
				break;
			case 4:
				// By the minute
				times = 365.25 * 24 * 60; // minutes in a year
				break;
			case 5:
				// By the second
				times = 365.25 * 24 * 60 * 60; // seconds in a year
				break;
			/* case 6: // this is for desktop OSes
				// By ticks
				times = 365.25 * 24 * 60 * 60 * TimeSpan.TicksPerSecond; // ticks in a year
				break; */
			case 6:
				// By the yottasecond
				// This isn't going to work without some major effort
				// the decimal and double types are not large enough to contain the numbers we need to work with
				times = 365.25 * 24 * 60 * 60 * Math.Pow (10, 6);
				//Console.WriteLine("YOTTA: " + times.ToString ());
				break;
			default:
				// Set the default to monthly:
				times = 12;
				break;
			}
			
			// final = principal * (1 + (interest rate / number of times compounded)) ^ (years compounded * number of times compounded)
			// F = P * (1 + r/n)^(n*t)
			// This is (interest rate / number of times compounded).
			double rn = Convert.ToDouble(rate) / times;
			// This is (years compounded * number of times compounded).
			double nt = Convert.ToDouble(time) * times;
			// This is the principal.
			double P = Convert.ToDouble(principal);
			// This is the final value.
			double F = P * Math.Pow(1 + rn, nt);
			/*Console.WriteLine ("*************");
			Console.WriteLine ("P = " + P.ToString ());
			Console.WriteLine ("rn = " + rn.ToString ());
			Console.WriteLine ("nt = " + nt.ToString ()); */
			// This is only the interest part, i.e. the final value - the principal.
			double interestOnly = Convert.ToDouble(F) - (double)principal;
			// This is the final value. 
			double interestAndPrincipal = Convert.ToDouble(F);
			
			return interestOnly;
		}

		bool DoHtml = true;
		string Html = string.Empty;
		#endregion


		
		#region Gestures interface methods
		
		private GestureDetector _gestureDetector;
		private int swipeMinVelocity = 100;
		private int swipeMinDistance = 150;

		public bool OnFling (MotionEvent e1, MotionEvent e2, float velocityX, float velocityY)
		{
			float dX = e2.GetX () - e1.GetX ();
			float dY = e2.GetY () - e1.GetY ();
			//Console.WriteLine(" dX = " + dX.ToString () + "   Dy = " + dY.ToString ());
			if (Math.Abs (dX) > swipeMinDistance) {

				string assHtml = AssembleHtml ();

				if (velocityX > swipeMinVelocity) {
					var second = new Intent (this, typeof(HtmlChart));
					second.PutExtra ("Fling", "Data from main Activity - right");
					second.PutExtra ("HtmlData", assHtml);
					StartActivity (second);

				} else if (Math.Abs (velocityX) > swipeMinVelocity) {
					var second = new Intent (this, typeof(HtmlChart));
					second.PutExtra ("Fling", "Data from main Activity - left");
					second.PutExtra ("HtmlData", assHtml);
					StartActivity (second);
				}
			
				return true;
			} else {
				return false;
			}
		}

		// http://stackoverflow.com/questions/4255847/how-to-implement-gesture-detector-onfling-in-webview-in-android/5150540#5150540
		// This enables flinging inside the scrollview.
		public override bool DispatchTouchEvent (MotionEvent e)
		{
			base.DispatchTouchEvent(e);
			return _gestureDetector.OnTouchEvent(e);
		}

		public override bool OnTouchEvent(MotionEvent e)
		{
			_gestureDetector.OnTouchEvent(e);
			return false;
		}
		
		public bool OnDown(MotionEvent e)
		{
			return false;
		}
		
		public void OnLongPress(MotionEvent e) {}
		
		public bool OnScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY)
		{
			return false;
		}
		
		public void OnShowPress(MotionEvent e) {}
		
		public bool OnSingleTapUp(MotionEvent e)
		{
			return false;
		}

		#endregion


		
		/// <summary>
		/// This section of icky HTML constants is simply so that the program can run as a stand-alone version.
		/// It would be better to stick it in a resource, but for the sake of non-programmers it is inline here
		/// as simple text so that they can more easily modify it. 
		/// </summary>
		#region Icky, messy HTML fragments as constant strings.
		const string html1 = @"<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3.org/TR/html4/loose.dtd'>
<html>
 <head>
  <title> Frackin' Reserve - Fractional Reserve Banking Simulation </title>
  <meta name='Generator' content='Ryan Smyth - Frackin Reserve - Fractional Reserve Banking Simulation'>
  <meta name='Author' content='Ryan Smyth'>
  <meta name='Keywords' content='Fractional reserve banking is evil'>
  <meta name='Description' content='Fractional reserve banking is evil'>
<style type='text/css'>
table {
	border-width: 1px;
	border-spacing: 2px;
	border-style: solid;
	border-color: black;
	
	background-color: white;
	-webkit-border-radius: 25px;
	-moz-border-radius: 25px;
	border-radius: 25px;
}
th {
	border-width: 1px;
	padding: 3px;
	border-style: solid;
	border-color: black;
	background-color: white;
	/*-webkit-border-radius: 25px;
	-moz-border-radius: 25px;
	border-radius: 25px;*/
    background-color: #f0f0f0;

}
td {
	border-width: 1px;
	padding: 3px;
	border-style: solid;
	border-color: black;
	background-color: white;
	/*-webkit-border-radius: 25px;
	-moz-border-radius: 25px;
	border-radius: 25px;*/
    text-align: right;
}
table tr:last-child td:first-child {
-moz-border-radius-bottomleft:25px;
-webkit-border-bottom-left-radius:25px;
border-bottom-left-radius:25px}

table tr:last-child td:last-child {
-moz-border-radius-bottomright:25px;
-webkit-border-bottom-right-radius:25px;
border-bottom-right-radius:25px}

  </style>
 </head>
 <body>
<p>Press the Android back button to return...</p>
<table cellspacing='0'>
<tr><th>Iteration #</th><th>Deposited by<br>Customer</th>
<th>Amount Held <br>in Reserve<br>from Deposit</th>
<th>Amount <br>Currrently <br>Available to <br>Lend Out<br>from Deposit</th>
<th>Total Amount that <br>&quot;Can&quot; be <br>Lent Out</th>
<th>Total Amount that <br>Has Been <br>Lent Out</th>
<th>Total Amount <br>Held in Reserve</th>
<th>Total Amount that <br>Customers Believe <br>They Have</th>
<th>Amount of <br>Interest for <br>{0} year(s) @ {1}%<br>on Loaned Money <br>CAN NEVER <br>BE REPAID! </th></tr>
";
		const string html2 = @"
<tr><td colspan='9' style='text-align: center;'> <b>Fractional Reserve Banking is EVIL.</b> </td></tr>
</table>
<p>For more information, read the <a href='http://cynic.me/tag/fractional-reserve-banking/'>Fractional Reserve Banking</a> 
articles that walk through exactly how and why fractional reserve banking is fraud. </p>
<p><a href='http://cynic.me/2012/05/28/frackin-reserve-the-mechanics-of-fractional-reserve-banking-1-6'>Part 1 &#8211; The Mechanics of Fractional Reserve Banking</a><br />
<a href='http://cynic.me/2012/05/28/frackin-reserve-what-is-money-2-6'>Part 2 &#8211; What is money?</a><br />
<a href='http://cynic.me/2012/05/28/frackin-reserve-how-fractional-reserve-banking-creates-money-and-why-it-is-fraudulent-3-6'>Part 3 &#8211; &#8220;How&#8221; Fractional Reserve Banking Creates Money and &#8220;Why&#8221; it is Fraudulent</a><br />
<a href='http://cynic.me/2012/05/28/frackin-reserve-run-on-the-banks-or-run-on-the-people-4-6'>Part 4 &#8211; Run on the Banks? Or Run on the People? </a><br />
<a href='http://cynic.me/2012/05/28/frackin-reserve-compound-interest-as-invisible-slavery-5-6'>Part 5 &#8211; Compound Interest as Invisible Slavery </a><br />
<a href='http://cynic.me/2012/05/28/frackin-reserve-summary-and-additional-resources-6-6'>Part 6 &#8211; Summary &amp; Additional Resources </a></p>

<p>Get Frackin' Reserve for Windows, Mac, Linux, or play with the web edition (source code available):</p>

<p><a href='http://cynic.me/2012/05/16/frackin-reserve-a-fractional-reserve-banking-simulator/'>Windows version</a><br />
<a href='http://cynic.me/2012/07/27/frackin-reserve-for-linux-and-mac-os-x/'>Mac &amp; Linux version</a><br />
<a href='http://cynic.me/2012/05/17/frackin-reserve-web-edition-a-fractional-reserve-banking-simulator/'>Web Edition</a></p>
<br /><br /><br /> 
</body>
</html>";
#endregion
		



	}

	



}


