
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Webkit;

namespace FrackinReserve
{
	[Activity (Label = "FRACKIN' RESERVE - Iteration Results Table")]			
	public class HtmlChart : Activity
	{

		protected override void OnCreate (Bundle bundle)
		{
			base.OnCreate (bundle);

			// Create your application here
			SetContentView(Resource.Layout.HtmlChart);

			// Get the HTML from the intent that we sent in the other Activity.
			html = Intent.GetStringExtra("HtmlData") ?? "Data not available";
			string fling = Intent.GetStringExtra("Fling") ?? "Data not available";
			Toast.MakeText (this, "Loading data... ", ToastLength.Short).Show ();

			WebView wv = FindViewById<WebView> (Resource.Id.wvChart);
			wv.SetWebChromeClient (new WebChromeClient ());
			wv.Settings.JavaScriptEnabled = true;
			// This doesn't work:
			//wv.LoadData (html, "text/html", null);
			// It works for smaller pages, but not for larger pages. i.e. anything useful.
			// Spent hours trying to get around that when I finally found this:
			// http://stackoverflow.com/questions/3312643/android-webview-utf-8-not-showing
			// Cripes... why can't stuff just work? This does though:
			wv.LoadDataWithBaseURL (null, html, "text/html", "utf-8", null);
			
		}

		#region Context menu
		public override bool OnCreateOptionsMenu (IMenu menu)
		{
			var omRateUs = menu.Add (0,1,1, "Rate FR!");
			var omVisitUs = menu.Add(0,2,2, "Visit FR!");
			
			//return base.OnCreateOptionsMenu (menu);
			return true;
		}
		
		public override bool OnOptionsItemSelected (IMenuItem item)
		{
			switch (item.ItemId) {
			case 1:
				// Do menu item 1
				RateThisApp();
				return true;
				break;
			case 2:
				// do menu item 2
				VisitFrackinReserve();
				return true;
				break;
			case 3:
				// Share this
				break;
			default:
				break;
			}
			
			return base.OnOptionsItemSelected(item);
		}

		
		
		private void VisitFrackinReserve ()
		{
			var intent = new Intent (Intent.ActionView, 
			                         Android.Net.Uri.Parse ("http://cynic.me/tag/fractional-reserve-banking/"));
			intent.AddFlags (ActivityFlags.NewTask);
			try {
				StartActivity (intent);
			} catch {
				Toast.MakeText(this.ApplicationContext, 
				               "Sorry... \r\nEither Cthulhu or the Banksters sabotaged our efforts...", ToastLength.Long).Show();
			}
		}
		
		private void RateThisApp ()
		{
			Android.Net.Uri uri = Android.Net.Uri.Parse("market://details?id=" + this.PackageName);
			
			Intent goToMarket = new Intent(Intent.ActionView, uri);
			goToMarket.AddFlags (ActivityFlags.NewTask);
			try {
				StartActivity(goToMarket);
			} catch (ActivityNotFoundException err) {
				// UtilityClass.ShowAlertDialog(Context, ERROR, "Couldn't launch the market", null, 0);
				Toast.MakeText(this.ApplicationContext, "Sorry... Couldn't launch the market...", ToastLength.Long).Show();
			}
		}

		#endregion

		string html = @"Encountered an error - chart is unavailable.";

	}
}

